=== modified file 'NEWS'
--- NEWS	2009-03-12 14:02:53 +0000
+++ NEWS	2009-03-13 00:13:11 +0000
@@ -36,6 +36,10 @@
       stackable-format branch with an unstackable-format repository to a
       destination with a default stacking policy.  (Andrew Bennetts)
 
+    * The GNU Changelog formatter is slightly improved in the case where
+      the delta is empty, and now correctly claims not to support tags.
+      (Andrea Bolognani)
+
   DOCUMENTATION:
 
     * The generated manpage now explicitly lists aliases as commands.

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2009-03-11 08:58:17 +0000
+++ bzrlib/log.py	2009-03-13 00:13:11 +0000
@@ -1374,11 +1374,10 @@
         return self.truncate(prefix + " ".join(out).rstrip('\n'), max_chars)
 
 
-class ChangeLogLogFormatter(LogFormatter):
+class GnuChangelogLogFormatter(LogFormatter):
 
     supports_merge_revisions = True
     supports_delta = True
-    supports_tags = True
 
     def log_revision(self, revision):
         """Log a revision, either merged or not."""
@@ -1392,7 +1391,7 @@
         committer_str = revision.rev.committer.replace (' <', '  <')
         to_file.write('%s  %s\n\n' % (date_str,committer_str))
 
-        if revision.delta is not None:
+        if revision.delta is not None and revision.delta.has_changed():
             for c in revision.delta.added + revision.delta.removed + revision.delta.modified:
                 path, = c[:1]
                 to_file.write('\t* %s:\n' % (path,))
@@ -1440,9 +1439,8 @@
                                 'Detailed log format')
 log_formatter_registry.register('line', LineLogFormatter,
                                 'Log format with one line per revision')
-log_formatter_registry.register(
-    'gnu-changelog', ChangeLogLogFormatter,
-    'Format used by GNU ChangeLog files')
+log_formatter_registry.register('gnu-changelog', GnuChangelogLogFormatter,
+                                'Format used by GNU ChangeLog files')
 
 
 def register_formatter(name, formatter):

